private import std.math;

private import opengl;

private import type;
private import log;
private import mymath;
private import mygl;

class Charactor {
public:
	this() {
		turn_ = 0;
		life_ = 1;
		alpha_ = 1;
	}
	~this() {
//		if (data_ !== null) delete data_;
	}

	void move() {
		x_ += sx_;
		y_ += sy_;
		turn_++;
	}

	float x() { return x_; }
	float y() { return y_; }

	float sx() { return sx_; }
	float sy() { return sy_; }

	void x(float x) {
		x_ = x;
	}
	void y(float y) {
		y_ = y;
	}
	void sx(float sx) {
		sx_ = sx;
	}
	void sy(float sy) {
		sy_ = sy;
	}

	float a() { return a_; }
	float s() { return s_; }
	void a(float a0) { a_ = a0; }
	void s(float s0) { s_ = s0; }

	bit alive() { return life_ > 0; }

	float life() { return life_; }
	void life(float life) { life_ = life; }

	bit collable() {
		return type_ > 0;
	}

	int dyingCnt() { return 0; }

	int turn() { return turn_; }

	Type type() { return type_; }

	void wait(int t) {}

	void setRGB(float r, float g, float b) {
		r_ = r;
		g_ = g;
		b_ = b;
	}

	float r() { return r_; }
	float g() { return g_; }
	float b() { return b_; }

	void draw() {
		switch (type_) {
		case (Type.SHOT_KNIFE): {
			glPushMatrix();

			glTranslatef(x_, y_, 0);
//			glRotatef(a_, 0, 0, 1);
			glRotatef(-rtod(a_), 0, 0, 1);
			glRotatef(-turn*4, 0, 1, 0);

			glBegin(GL_TRIANGLE_FAN);
			glColor4f(1, 1, 1, 0.9);
			glVertex3f(2, 10, 0);
			glVertex3f(-3, -5, 0);
			glVertex3f(3, -5, 0);
			glEnd();

			glBegin(GL_QUADS);
			glColor4f(0.7, 0.7, 0.5, 0.9);
			glVertex3f(2, -15, 0);
			glVertex3f(-2, -15, 0);
			glVertex3f(-2, -5, 0);
			glVertex3f(2, -5, 0);
			glEnd();

			glPopMatrix();

			break;
		}
		case (Type.SHOT_CORE): {
			glPushMatrix();

			glTranslatef(x_, y_, 0);

			glBegin(GL_QUADS);
			glColor4f(r_, g_, b_, 0.2*alpha_);
			glVertex3f(0, -10, 0);
			glVertex3f(10*std.math.sin(turn_*0.05), 0, 0);
			glVertex3f(0, 10, 0);
			glVertex3f(-10*std.math.sin(turn_*0.05), 0, 0);
			glEnd();

			glBegin(GL_QUADS);
			glColor4f(r_, g_, b_, 0.2*alpha_);
			glVertex3f(-10, 0, 0);
			glVertex3f(0, 10*std.math.cos(turn_*0.05), 0);
			glVertex3f(10, 0, 0);
			glVertex3f(0, -10*std.math.cos(turn_*0.05), 0);
			glEnd();

			glBegin(GL_LINE_LOOP);
			glColor4f(r_, g_, b_, alpha_);
			glVertex3f(0, -10, 0);
			glVertex3f(10*std.math.sin(turn_*0.05), 0, 0);
			glVertex3f(0, 10, 0);
			glVertex3f(-10*std.math.sin(turn_*0.05), 0, 0);
			glEnd();
			glBegin(GL_LINE_LOOP);
			glColor4f(r_, g_, b_, alpha_);
			glVertex3f(-10, 0, 0);
			glVertex3f(0, 10*std.math.cos(turn_*0.05), 0);
			glVertex3f(10, 0, 0);
			glVertex3f(0, -10*std.math.cos(turn_*0.05), 0);
			glEnd();

			glPopMatrix();

			break;
		}
		case (Type.SHOT_LIGHT): {
			glPushMatrix();

			glTranslatef(x_, y_, 0);

			glColor4f(r_, g_, b_, 0.2*alpha_);

			static int[] ints = [ -139, -77, -7, 23, 103, 207 ];

			glPushMatrix();
			foreach (int i; ints) {
				glRotatef(turn_*i, 0, 0, 1);

				glBegin(GL_TRIANGLE_FAN);

				glVertex3f(0, 10, 0);
				glVertex3f(7, -5, 0);
				glVertex3f(-7, -5, 0);

				glEnd();
			}
			glPopMatrix();

			glPopMatrix();

			break;
		}
		case (Type.SHOT_CIRCLE): {
			glPushMatrix();

			glTranslatef(x_, y_, 0);

			glColor4f(r_, g_, b_, 0.8*alpha_);

			myglCircle8(2);

			glPopMatrix();

			break;
		}
		case (Type.ENEMY_WALL): {
			glPushMatrix();

			glTranslatef(x_, y_, 0);

			glColor4f(r_, g_, b_, 0.3);

			glBegin(GL_QUADS);

			glVertex3f(-60, -20, 0);
			glVertex3f(-60, 20, 0);
			glVertex3f(60, 20, 0);
			glVertex3f(60, -20, 0);

			float s = sin(turn_*0.01);
			glVertex3f(-60-(sx_+s)*10, -20-sy_*10, 0);
			glVertex3f(-60-(sx_+s)*10, 20-sy_*10, 0);
			glVertex3f(60-(sx_-s)*10, 20-sy_*10, 0);
			glVertex3f(60-(sx_-s)*10, -20-sy_*10, 0);

			glEnd();

			glPopMatrix();

			break;
		}
		case (Type.ENEMY_BLOCK): {
			glPushMatrix();

			glTranslatef(x_, y_, 0);

			glColor4f(r_, g_, b_, 0.3);

			int c = (turn_ > 30) ? 30 : turn_;

			glRotatef(turn_*0.13, 0, 0, 1);
			glBegin(GL_QUADS);
			glVertex3f(-c, -c, 0);
			glVertex3f(-c, c, 0);
			glVertex3f(c, c, 0);
			glVertex3f(c, -c, 0);
			glEnd();

			glRotatef(-turn_*0.26, 0, 0, 1);
			glBegin(GL_QUADS);
			glVertex3f(-c, -c, 0);
			glVertex3f(-c, c, 0);
			glVertex3f(c, c, 0);
			glVertex3f(c, -c, 0);
			glEnd();

			if (turn > 30) {
				myglCircle8(5);
			}

			glPopMatrix();

			break;
		}
		case (Type.ENEMY_POINT): {
			glPushMatrix();

			glTranslatef(x_, y_, 0);

			glColor4f(r_, g_, b_, 0.3);

			float c = (turn_ > 30) ? 30 : turn_;
			c /= 8;

			glRotatef(turn_*13, 0, 0, 1);
			glBegin(GL_QUADS);
			glVertex3f(-c, -c, 0);
			glVertex3f(-c, c, 0);
			glVertex3f(c, c, 0);
			glVertex3f(c, -c, 0);
			glEnd();

			glRotatef(-turn_*26, 0, 0, 1);
			glBegin(GL_QUADS);
			glVertex3f(-c, -c, 0);
			glVertex3f(-c, c, 0);
			glVertex3f(c, c, 0);
			glVertex3f(c, -c, 0);
			glEnd();

			if (turn > 30) {
				glColor4f(1, 1, 1, 0.3);

				myglCircle8(5);
			}

			glPopMatrix();

			break;
		}
		case (Type.ENEMY_BALLS): {
			glPushMatrix();

			glTranslatef(x_, y_, 0);

			glColor4f(r_, g_, b_, 0.5);

			float c = turn_ * 0.03;

			for (int i = 0; i < 3; i++) {
				float r = 10 * sin(c);
				float a = 30 * sin(c) + i * PI * 0.6667;
				myglCircle16(r*sin(a), r*cos(a), 7);
			}

			glPopMatrix();

			break;
		}
		case (Type.PLAYER_MAINSHOT): {
			glPushMatrix();

			glTranslatef(x_, y_, 0);

			glColor4f(0.8, 0.8, 1, 0.1);

			static int[] ints = [ -139, -77, -7, 23, 103, 207 ];

			glPushMatrix();
			foreach (int i; ints) {
				glRotatef(turn_*i, 0, 0, 1);

				glBegin(GL_TRIANGLE_FAN);

				glVertex3f(0, 20, 0);
				glVertex3f(14, -10, 0);
				glVertex3f(-14, -10, 0);

				glEnd();
			}
			glPopMatrix();

/*
			glBegin(GL_TRIANGLES);
			foreach (int i; ints) {
				float c = cos(dtor(i*turn_));
				float s = sin(dtor(i*turn_));
				glVertex3f(s*20, c*20, 0);
				glVertex3f(c*14-s*10, -s*14-c*10, 0);
				glVertex3f(-c*14-s*10, s*14-c*10, 0);
			}
			glEnd();
*/
			glColor4f(0, 0, 0, 0.2);
/*
			glBegin(GL_TRIANGLES);
			foreach (int i; ints) {
				float c = cos(dtor(i*turn_));
				float s = sin(dtor(i*turn_));
				glVertex3f(s*20, c*20, 0);
				glVertex3f(c*14-s*10, -s*14-c*10, 0);
				glVertex3f(-c*14-s*10, s*14-c*10, 0);
			}
			glEnd();
*/
			glPushMatrix();
			foreach (int i; ints) {
				glRotatef(turn_*i, 0, 0, 1);

				glBegin(GL_TRIANGLE_FAN);

				glVertex3f(0, 19, 0);
				glVertex3f(13, -9, 0);
				glVertex3f(-13, -9, 0);

				glEnd();
			}
			glPopMatrix();

			glPopMatrix();

			break;
		}
		case (Type.PLAYER_MAINLASER): {
			glPushMatrix();

			glTranslatef(x_, y_, 0);

			glColor4f(1, 0.9, 0.9, 0.6);
/*
			foreach (int i; ints) {
*/
				glBegin(GL_QUADS);

				glVertex3f(-15, -15, 0);
				glVertex3f(15, -15, 0);

				glVertex3f(15, 15, 0);
				glVertex3f(-15, 15, 0);

				glEnd();
/*
			}
*/
			static int[] ints = [ -139, -77, /*-7, 23,*/ 103, 207 ];

			glColor4f(0, 0.05, 0, 0.3);

			foreach (int i; ints) {
				glPushMatrix();

				glRotatef(turn_*i, 0, 0, 1);

				glBegin(GL_QUADS);

				glVertex3f(-25, -20, 0);
				glVertex3f(25, -20, 0);
				glVertex3f(25, 20, 0);
				glVertex3f(-25, 20, 0);

				glEnd();

				glPopMatrix();
			}

			glPopMatrix();

			break;
		}
		case (Type.NONE): {
			break;
		}
		default: {
			Log.error("unknown type charactor: " ~ std.string.toString(type_));
		}
		}
	}

protected:
	float x_, y_;
	float sx_, sy_;
	float a_, s_;
	int turn_;
	Type type_;
	float life_;
	Object data_;
	float r_, g_, b_, alpha_;

}
