private import std.random;

private import opengl;

private import letter;
private import mymath;

class Effect {
public:
	void run() {
		turn_++;
	}

	void draw() {
		proc_();
	}

	bit isEnd() {
		return false;
	}

protected:
	this() {
		turn_ = 0;
	}
	this(int x, int y) {
		this();
		x_ = x;
		y_ = y;
	}

	abstract void proc_();

private:
	int x_, y_;
	int turn_;

}

class ShotVanishEffect : Effect {
	this(int x, int y, float sx, float sy,
		 float r, float g, float b) {
		super(x, y);
		sx_ = sx;
		sy_ = sy;
		r_ = r;
		g_ = g;
		b_ = b;

		ex_[] = x;
		ey_[] = y;
		for (int i = 0; i < 6; i++) {
			esx_[i] = sx+rnd(1.0f)-0.5;
			esy_[i] = sy+rnd(1.0f)-0.5;
		}
	}

	bit isEnd() {
		return turn_ > 20;
	}

	void proc_() {
		glColor4f(r_, g_, b_, 0.15-turn_/200);

		glBegin(GL_TRIANGLE_FAN);

		x_ += sx_;
		y_ += sy_;

		glVertex3f(x_, y_, 0);

		for (int i = 0; i < 6; i++) {
			ex_[i] += esx_[i];
			ey_[i] += esy_[i];
			glVertex3f(ex_[i], ey_[i], 0);
//			glVertex3f(ex_[i+1], ey_[i+1], 0);
		}

		glEnd();
	}

	float sx_, sy_;
	float r_, g_, b_;
	float[6] ex_, ey_, esx_, esy_;
}

class StringEffect : Effect {
public:
	this(int x, int y, char[] str, float sx, float sy,
		 float r, float g, float b) {
		super(x, y);
		str_ = str;
		sx_ = sx;
		sy_ = sy;
		r_ = r;
		g_ = g;
		b_ = b;
	}

	bit isEnd() {
		return turn_ > 100;
	}

	void proc_() {
		drawString(str_, x_, y_, sx_, sy_, r_, g_, b_);
	}

private:
	char[] str_;
	float sx_, sy_;
	float r_, g_, b_;
}

