private import std.string;
private import std.math;
private import std.gc;

private import lua;
private import SDL;
private import opengl;
private import openglu;

private import kk;
private import player;
private import shot;
private import log;
private import bullet;
private import charactor;
private import stage;
private import mymath;
private import myio;
private import homing;
private import letter;
private import effect;
private import type;
private import texture;
private import sound;
private import score;

Texture bg;

class Game {
private:
	static Game obj_;
public:
	static Game obj() {
		return obj_;
	}

public:
	this() {
		obj_ = this;

		player_ = new Player(this, Kk.obj().padInput());

		foreach (inout Shot s; shots_) {
			s = null;
		}
		shotNum_ = 0;
		foreach (inout Enemy s; enemys_) {
			s = null;
		}
		foreach (inout Shot s; pshots_) {
			s = null;
		}
		pshotIte_ = 0;
		foreach (inout HomingShot s; roks_) {
			s = null;
		}
		foreach (inout int i; rokInvokeCnts_) {
			i = 0;
		}
		foreach (inout Effect e; effects_) {
			e = null;
		}
		effectIte_ = 0;

		turn_ = 0;

		screenWidth_ = Kk.rc().getInt("screenWidth");
		screenHeight_ = Kk.rc().getInt("screenHeight");
		gameWidth_ = Kk.rc().getInt("gameWidth");
		gameHeight_ = Kk.rc().getInt("gameHeight");
		gameScreenX_ = Kk.rc().getInt("gameScreenX");
		gameScreenY_ = Kk.rc().getInt("gameScreenY");
		gameScreenWidth_ = Kk.rc().getInt("gameScreenWidth");
		gameScreenHeight_ = Kk.rc().getInt("gameScreenHeight");

		playerCollSize_ = Kk.rc().getFloat("playerCollSize");
		playerCollSize2_ = playerCollSize_*playerCollSize_;
		playerCounterSize_ = Kk.rc().getFloat("playerCounterSize");
		playerCounterSize2_ = playerCounterSize_*playerCounterSize_;

		enemyCollSize_ = Kk.rc().getFloat("enemyCollSize");
		enemyInvTurn_ = Kk.rc().getInt("enemyInvTurn");

		stageNum_ = Kk.rc().getInt("stage") - 1;

		useBgTexture_ = Kk.rc().getBit("useBgTexture");
		if (!useBgTexture_) glClearColor(0.1, 0.1, 0.1, 0);

		rokSlowDown_ = Kk.rc().getFloat("rokSlowDown");

		stage_ = null;
		score_ = new Score();

		// @@@ temporary code
		bg = new Texture("bgl.bmp");

		std.gc.fullCollect();
		std.gc.disable();
	}

	bit isEnd() {
		return isEnd_;
	}

	void run() {
		runStage();
		runPlayer();
		runShot();
		// player shot must be processed after shot.
		// because homing laser depends on this order.
		runPshot();
		runEffect();
		procDead();
		if (bossScore_ > 0 && stageEndCnt_ == 0) {
			bossScore_ -= bossScoreDec_;
			if (bossScore_ < 0) bossScore_ = 0;
		}
		if (!Kk.obj().timer().shouldSkip()) {
			draw();
		}

		turn_++;
	}

	void runStage() {
		if (stageEndCnt_) {
			stageEndCnt_++;
			if (stageEndCnt_ > 600) {
				stageEndCnt_ = 0;
				delete stage_;
				stage_ = null;
			}
		}
		else {
			if (!stage_) {
				while (!stage_) {
				    stageNum_++;
					Log.dbg(stageNum_);
				    try {
			 	 	    stage_ = new Stage(stageNum_);
				    }
				    catch (Exception e) {
				    	// @@@ temporary...
						if (stageNum_ > 7) {
					    	Kk.obj.setEnd();
							throw new Exception("game ended");
					    	return;
						}
				    }
				}

				char[] stageStr = tostr(stageNum_);

				addEffect(new StringEffect(
							  150, 350, "STAGE" ~ stageStr,
							  20, 20,
							  1, 1, 1));

				char[] music = Kk.rc().get("stageMusic" ~ stageStr);
				Sound.obj.loadMusic(music);
				Sound.obj.playMusic();

				sceneNum_ = 0;
				bossScore_ = 0;

				player_.resetRokNum();
			}
			stage_.run();
		}
	}

	void procDead() {
		for (int i = 0; i < roks_.length; i++) {
			if (roks_[i] && !roks_[i].alive()) {
				delete roks_[i];
				roks_[i] = null;
				rokInvokeCnts_[i] = 60;
			}
		}
		foreach (inout Shot s; pshots_) {
			if (s && !s.alive()) {
				delete s;
				s = null;
			}
		}
		foreach (inout Shot s; shots_) {
			if (s && !s.alive()) {
				delete s;
				s = null;
			}
		}
		foreach (inout Enemy s; enemys_) {
			if (s && !s.alive()) {
				int rokFact = ((rokInvokeNum_ > s.dyingRokFactor)
							   ? rokInvokeNum_ : s.dyingRokFactor) + 1 + rokOverNum_;
				if (rokFact > 100) rokFact = 100;

				score_.add(s.score * rokFact);
//				score_ += sqrt(cast(float)s.firstLife) * rokMag_ * 100;

				if (rokFact != 1) {
					addEffect(new StringEffect(
								  s.x(), s.y(), tostr(rokFact),
								  8+(rokFact>>1), 8+(rokFact>>1),
								  1, 1, 1));
				}
//					addEffect(new StringEffect(s.x(), s.y(), rokMag_));

				if (s == boss_) {
					boss_ = null;
				}

				delete s;
				s = null;
			}
		}
		foreach (inout Effect e; effects_) {
			if (e && e.isEnd()) {
				delete e;
				e = null;
				effectNum_--;
			}
		}
	}

	void runPlayer() {
		player_.move();
	}

	void runShot() {
		float px = player_.x;
		float py = player_.y;

		void procShot(Shot s) {
			s.move();

			float x = s.x();
			float y = s.y();
			float sx = s.sx();
			float sy = s.sy();
			// ̳
			if (x < -10 || y < -10 ||
				x > gameWidth_+10 || y > gameHeight_+10)
			{
				s.vanish();
				shotNum_--;
				return;
			}

			float dx = px - x;
			float dy = py - y;
			float len2 = dx * dx + dy * dy;

			float bs = player_.barrierSize;
			if (bs == 0) {
				if (!s.isCounterable() && len2 < 2500) {
					// ˹Ԥä
					float a = angle(dx, dy);
					if (fabs(relAngle(a - s.a)) > std.math.PI*rokSlowDown_) {
						s.setCounterable();
					}
				}

				if (s.isCounterable() && len2 < playerCounterSize2_) {
					vanishShot(s);
/*
					s.vanish();
					shotNum_--;
*/
					player_.addRokNum();
					score_.addRok();
					return;
				}
			}
			else if (bs > 0) {
				// Хꥢ
				if (len2 < bs*bs*4) {
					s.setCounterable();
					if (!(Enemy)s) {
						vanishShot(s);
/*
						s.vanish();
						shotNum_--;
*/
						return;
					}
					else if (s.turn > enemyInvTurn_) {
						s.life = s.life - 3;
					}
				}
			}
			else {
				if (len2 < bs*bs*4 || (fabs(dx) < -bs*2 && dy > 0)) {
					s.setCounterable();
					if (!(Enemy)s) {
						vanishShot(s);
/*
						s.vanish();
						shotNum_--;
*/
						return;
					}
					else if (s.turn > enemyInvTurn_) {
						s.life = s.life - 10;
						if (s.life == 0) score_.addDestroy();
					}
				}
			}

			if (len2 < playerCollSize2_ && (Enemy)s === null &&
				stageEndCnt_ == 0) {
				Sound.obj.playChunk(Se.PLAYER_DEAD);
				player_.damage();
			}
		}

		int num = 0;
		if (player_.damaging()) {
			vanishAllShot();
		}
		else {
			foreach (inout Shot s; shots_) {
				if (!s) continue;
				procShot(s);
				num++;
			}
		}
		foreach (inout Enemy s; enemys_) {
			if (!s) continue;
			procShot(s);
			num++;
		}

		if (num > 500) {
			Kk.obj().timer().slow(1);
		}
		else if (num > 200) {
			Kk.obj().timer().slow(2);
		}
		else {
			Kk.obj().timer().slow(0);
		}
		objectNum_ = num;
	}

	void procPshot(Shot s) {
		if (!s) return;

		s.move();

		float x = s.x();
		float y = s.y();
		if (x < -50 || y < -50 ||
			x > gameWidth_+50 || y > gameHeight_+50)
		{
			s.vanish();
			return;
		}
		foreach (Enemy t; enemys_) {
			if (t && t.collable() && t.isColl(x, y)) {
				// rok Τߴ̵ŨŨ˾äʤ
				if ((HomingShot)s) {
					if (t.turn > enemyInvTurn_) {
						if (s.life < t.life) {
							t.life = t.life - s.life;
							s.vanish();
						}
						else {
							s.life = s.life - t.life;
							score_.addDestroy();
							t.destroy();
							t.dyingRokFactor = rokInvokeNum_;
						}
					}
				}
				else {
					if (t.turn > enemyInvTurn_) {
						if (s.life < t.life) {
							t.life = t.life - s.life;
						}
						else {
							t.destroy();
							score_.addDestroy();
							t.dyingRokFactor = rokInvokeNum_;
						}
					}
					s.vanish();
				}
				break;
			}
		}
	}

	void runPshot() {
		rokInvokeNum_ = 0;
		foreach (inout int i; rokInvokeCnts_) {
			if (player_.barrierSize == 0) i--;
			if (i > 0) rokInvokeNum_++;
		}
		if (rokInvokeNum_ != 15) rokOverNum_ = 0;
//		if (rokInvokeNum_ == 0) rokMag_ = 0;
		foreach (inout Shot s; pshots_) {
			procPshot(s);
		}
		foreach (inout HomingShot s; roks_) {
			procPshot(s);
		}
	}

	void runEffect() {
		foreach (Effect e; effects_) {
			if (e) {
				e.run();
			}
		}
	}

	void draw() {
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

		if (useBgTexture_) {

		static float t = 0.01;
		t += 0.001;
		glDisable(GL_BLEND);
		glEnable(GL_TEXTURE_2D);
		bg.bind();
		glColor4f(1, 1, 1, 1);

		GLfloat[] texcoord = bg.texcoord;

		glBegin(GL_QUADS);
		glTexCoord3f(texcoord[0]+0.3*std.math.cos(t*7),
					 texcoord[1]+0.3*std.math.cos(t*97), 0);
		glVertex3f(0, -16, 0);
		glTexCoord3f(texcoord[0]+0.3*std.math.cos(t*77),
					 texcoord[3]+0.3*std.math.cos(t*17), 0);
		glVertex3f(0, 496, 0);
		glTexCoord3f(texcoord[2]+0.3*std.math.cos(t*27),
					 texcoord[3]+0.3*std.math.cos(t*67), 0);
		glVertex3f(600, 496, 0);
		glTexCoord3f(texcoord[2]+0.3*std.math.cos(t*57),
					 texcoord[1]+0.3*std.math.cos(t*37), 0);
		glVertex3f(600, -16, 0);
		glEnd();

		glEnable(GL_BLEND);
		glDisable(GL_TEXTURE_2D);

		}

		{
//			float r = (float)screenWidth_ / 640;
//			glViewport(170, 25, gameWidth_*r, gameHeight_*r);
			glViewport(gameScreenX_, gameScreenY_,
					   gameScreenWidth_, gameScreenHeight_);

			glMatrixMode(GL_PROJECTION);
			glLoadIdentity();
			float asp = cast(float)gameWidth_ / gameHeight_;
			gluPerspective(44.0, asp, 0.1, 500);
		}

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
//		glViewport(170, 40, 300, 400);
		gluLookAt(320, 240, -500, 320, 240, 0, 0, -1, 0);

		glPushMatrix();

		glTranslatef(170, 40, 0);

		foreach (Shot s; pshots_) {
			if (s) {
				s.draw();
			}
		}
		foreach (HomingShot s; roks_) {
			if (s) {
				s.draw();
			}
		}

		foreach (Effect e; effects_) {
			if (e) {
				e.draw();
			}
		}

		player_.draw();

		foreach (Shot s; shots_) {
			if (s) {
				s.draw();
			}
		}
		foreach (Enemy s; enemys_) {
			if (s) {
				s.draw();
			}
		}

		player_.drawTop();

		if (boss_) {
			float life = boss_.life;
			if (boss_.turn < 100) life *= boss_.turn * 0.01;
			float lifeX = 250 * life / bossLifeMax_;

			glColor4f(1, 1, 1, 0.5);

			glBegin(GL_QUADS);
			glVertex3f(25, 25, 0);
			glVertex3f(25+lifeX, 25, 0);
			glVertex3f(25+lifeX, 40, 0);
			glVertex3f(25, 40, 0);
			glEnd();
		}
		if (bossScore_ > 0) {
			drawNum(bossScore_, 10, 10, 8, 10, 1, 1, 1);
		}

		drawField();

		glPopMatrix();

		{
			glViewport(0, 0, screenWidth_, screenHeight_);

			glMatrixMode(GL_PROJECTION);
			glLoadIdentity();
			float asp = cast(float)screenWidth_ / screenHeight_;
			gluPerspective(45.0, asp, 0.1, 1000);

			glMatrixMode(GL_MODELVIEW);
			glLoadIdentity();
			gluLookAt(320, 240, -500, 320, 240, 0, 0, -1, 0);
		}

		drawShadow();

		drawResult();

		drawInfo();

	}

	void drawShadow() {
		float shadow = 0;
		if (turn_ < 50) {
			shadow = (50-turn_)*0.02;
		}
		if (stageEndCnt_ > 60) {
			shadow = (stageEndCnt_-60)*0.02;
		}
		if (shadow > 0) {
			glColor4f(0, 0, 0, shadow);

			glBegin(GL_QUADS);
			glVertex3f(0, 0, 0);
			glVertex3f(screenWidth_, 0, 0);
			glVertex3f(screenWidth_, screenHeight_, 0);
			glVertex3f(0, screenHeight_, 0);
			glEnd();
		}
	}

	void drawField() {
		glBegin(GL_LINE_LOOP);
		glColor3f(1, 1, 1);
		glVertex3f(0, 0, 0);
		glVertex3f(gameWidth_, 0, 0);
		glVertex3f(gameWidth_, gameHeight_, 0);
		glVertex3f(0, gameHeight_, 0);
		glEnd();
	}

	void drawInfo() {
		drawString("SCORE", 50, 170, 12, 16, 1,1,1);
		drawNumR(score_.val(), 145, 195, 12, 16, 1,1,1);

		drawString("ROKS", 50, 300, 12, 16, 1,1,1);
		drawNumR(player_.rokNum(), 145, 300, 12, 16, 1,1,1);

		glBegin(GL_QUADS);
		glColor4f(1, 1, 1, 0.7);

		for (int i = 0; i < ROK_NUM; i++) {
			int cnt = rokInvokeCnts_[i];
			if (cnt > 0) {
				if (cnt > 1000) {
					cnt = 60;
				}
				glVertex3f(50+i*6, 380-cnt, 0);
				glVertex3f(55+i*6, 380-cnt, 0);
				glVertex3f(55+i*6, 380, 0);
				glVertex3f(50+i*6, 380, 0);
			}
		}
		glEnd();

		drawString("RATIO", 50, 400, 12, 16, 1,1,1);
		int rokRatio = rokInvokeNum_+rokOverNum_+1;
		if (rokRatio > 100) rokRatio = 100;
		drawNumR(rokRatio, 145, 400, 12, 16, 1,1,1);

		drawString("BARRIER", 50, 230, 12, 16, 1,1,1);
		glBegin(GL_QUADS);
		glVertex3f(55, 260, 0);
		glVertex3f(55, 250, 0);
		glVertex3f(55+player_.barrierGauge, 250, 0);
		glVertex3f(55+player_.barrierGauge, 260, 0);
		glEnd();

	}

	void drawResult() {
		if (stageEndCnt_ < 100) return;
		if (stageEndCnt_ == 100) nextScene();

		drawResultStringC("STAGE" ~ tostr(stageNum_) ~ " RESULT", 80);
		drawResultStringC("SCORE", 120);
		drawResultStringC(tostr(score_.val()), 140);

		for (int i = 0; i < sceneNum_-1; i++) {
			drawResultStringL("SCENE" ~ tostr(i), 170+i*15);
			drawResultStringR(tostr(score_.getSceneScore(i)), 170+i*15);
		}
	}

	private void drawResultStringC(char[] str, int y) {
		drawString(str, (640-12*str.length)/2, y, 12, 16, 1, 1, 1);
	}
	private void drawResultStringL(char[] str, int y) {
		drawString(str, 200, y, 12, 16, 1, 1, 1);
	}
	private void drawResultStringR(char[] str, int y) {
		drawString(str, 440-12*str.length,
				   y, 12, 16, 1, 1, 1);
	}

	void vanishShot(Shot s) {
		if (effectNum_ < 150) {
			addEffect(new ShotVanishEffect(
						  s.x(), s.y(), s.sx(), s.sy(),
						  s.r(), s.g(), s.b()));
		}
		s.vanish();
		shotNum_--;
	}

	void vanishBullet(Charactor bullet) {
		Enemy e = (Enemy)bullet;
		if (e) {
			e.score = 0;
			e.destroy();
			shotNum_--;
			return;
		}
		Shot s = (Shot)bullet;
		if (s) {
			vanishShot(s);
		}
/*
		foreach (Enemy s; enemys_) {
			if (s && s == bullet) {
				s.score = 0;
				s.destroy();
				shotNum_--;
				return;
			}
		}
		foreach (Shot s; shots_) {
			if (s && s == bullet) {
				s.vanish();
				shotNum_--;
				return;
			}
		}
*/
		assert(false);
	}

	Player player() {
		return player_;
	}

	int turn() { return turn_; }

	int screenWidth() { return screenWidth_; }
	int screenHeight() { return screenHeight_; }
	int gameWidth() { return gameWidth_; }
	int gameHeight() { return gameHeight_; }

	void addShot(Shot shot) {
		foreach (inout Shot s; shots_) {
			if (!s) {
				s = shot;
				shotNum_++;
				score_.addShot();
				return;
			}
		}
	}
	void addEnemy(Enemy shot) {
		foreach (inout Enemy s; enemys_) {
			if (!s) {
				s = shot;
				shotNum_++;
				score_.addEnemy();
				return;
			}
		}
		Log.warn("enemy cant be aborn!");
	}

	void addPshot(Shot shot) {
		while (pshots_[pshotIte_] !== null && (HomingShot)pshots_[pshotIte_]) {
			pshotIte_++;
			pshotIte_ &= PSHOT_NUM - 1;
		}
		if (pshots_[pshotIte_] !== null) {
			return;
		}
		pshots_[pshotIte_] = shot;
		pshotIte_++;
		pshotIte_ &= PSHOT_NUM - 1;
	}

	bit addRok(HomingShot shot) {
		int minIte = -1;
		int min = 1000;
		for (int i = 0; i < roks_.length; i++) {
			if (min > rokInvokeCnts_[i]) {
				min = rokInvokeCnts_[i];
				minIte = i;
			}
		}

		if (minIte != -1) {
			roks_[minIte] = shot;
			rokInvokeCnts_[minIte] = 10000;

			if (rokInvokeNum_ == 15) rokOverNum_++;

			return true;
		}
		else {
			return false;
		}

	}

	Enemy[] enemys() {
		return enemys_;
	}

	void addEffect(Effect e) {
		if (effects_[effectIte_] !== null) {
			Log.warn("over effects.");
			return;
		}
		effects_[effectIte_] = e;
		effectIte_++;
		effectNum_++;
		if (effectIte_ >= effects_.length) {
			effectIte_ = 0;
		}
	}

	int objectNum() {
		return objectNum_;
	}

	bool canPlayerShot(int num) {
		int n = 0;
		foreach (Shot s; pshots_) {
			if (s) n++;
		}
		return n + num < PSHOT_NUM;
	}

	void bossApproach(Enemy boss) {
		boss_ = boss;

		char[] music = Kk.rc().get("bossMusic" ~ tostr(stageNum_));
		Sound.obj.loadMusic(music);
		Sound.obj.playMusic();

		bossLifeMax_ = boss.life;

		bossScore_ = 200000;
		bossScoreDec_ = Kk.rc.getInt("bossScoreDec" ~ tostr(stageNum_));
	}

	void nextScene() {
		sceneNum_++;

		addEffect(new StringEffect(
					  150, 350, "SCENE" ~ tostr(sceneNum_),
					  20, 20,
					  1, 1, 1));

		score_.nextScene();
	}

	void stageEnd() {
		stageEndCnt_ = 1;
		score_.add(bossScore_);
	}

	void vanishAllShot() {
		foreach (inout Shot s; shots_) {
			if (!s) continue;
			vanishShot(s);
		}
		shotNum_ == 0;
	}

private:
	bit isEnd_;

	Player player_;

	static const int ROK_NUM = 15;
	HomingShot[ROK_NUM] roks_;
	int[ROK_NUM] rokInvokeCnts_;
	int rokInvokeNum_;
	int rokOverNum_;
//	int rokMag_;

	static const int PSHOT_NUM = 64;
	Shot[PSHOT_NUM] pshots_;
	int pshotIte_;

	int shotNum_;

	static const int SHOT_NUM = 3000;
	Shot[SHOT_NUM] shots_;

	static const int BULLET_NUM = 200;
	Enemy[BULLET_NUM] enemys_;

	Enemy boss_;
	float bossLifeMax_;
	int bossScore_;
	int bossScoreDec_;

	static const int EFFECT_NUM = 300;
	Effect[EFFECT_NUM] effects_;
	int effectIte_;
	int effectNum_;

	int turn_;

	int stageNum_;
	Stage stage_;
	int sceneNum_;
	int stageEndCnt_;

	int objectNum_;

	Score score_;

private:
	int screenWidth_;
	int screenHeight_;

	int gameWidth_;
	int gameHeight_;

	int gameScreenX_;
	int gameScreenY_;
	int gameScreenWidth_;
	int gameScreenHeight_;

	float playerCollSize_;
	float playerCollSize2_;
	float playerCounterSize_;
	float playerCounterSize2_;

	float enemyCollSize_;

	int enemyInvTurn_;

	bool useBgTexture_;

	float rokSlowDown_;

};
