private import SDL;

private import log;
private import std.string;

class Joystick {
public:
	this(int index) {
		joystick_ = SDL_JoystickOpen(index);
		if (joystick_ == (SDL_Joystick*)0) {
			Log.warn("cannot open joystick" ~ std.string.toString(index));
		}
		else {
			Log.info("joystick " ~ std.string.toString(index) ~ " opened");
		}
	}
	~this() {
		if (isInited()) SDL_JoystickClose(joystick_);
	}

	bit isInited() { return joystick_ != (SDL_Joystick*)0; }

	Sint16 axis(int axis) {
		return SDL_JoystickGetAxis(joystick_, axis);
	}
	Sint16 axisX() {
		return axis(0);
	}
	Sint16 axisY() {
		return axis(1);
	}

	Uint8 getButton(int button) {
		return 1 == SDL_JoystickGetButton(joystick_, button);
	}

private:
	SDL_Joystick* joystick_;

};

class JoystickMgr {
private:
	static JoystickMgr obj_;
public:
	static JoystickMgr obj() {
		return obj_;
	}

	this() {
		Log.info("init joystick manager");
		obj_ = this;
	}

public:
	/**
	 * @return
	 * 顼ξ null ֤
	 * ϡJoystick  open ǤʤȤ뤫Ȼפ
	 */
	Joystick getJoystick(int index) {
		checkInit();

		if (!inited_) return null;

		if (!checkJoysticksSize(index)) return null;

		if (!joysticks_[index]) {
			joysticks_[index] = new Joystick(index);
		}

		if (joysticks_[index].isInited()) {
			return joysticks_[index];
		}
		else {
			return null;
		}
	}

private:
	bit checkJoysticksSize(int index) {
		while (joysticks_.length <= index) {
			joysticks_ ~= null;
		}
		return true;
	}

	void checkInit() {
		inited_ = true;
		if (!SDL_WasInit(SDL_INIT_JOYSTICK)) {
			SDL_InitSubSystem(SDL_INIT_JOYSTICK);
			Log.info("joystick inited");
		}
		else {
		}
	}

private:
	bit inited_;
	Joystick joysticks_[];

};


