private import std.string;
private import std.math;

private import kk;
private import padinput;
private import mymath;
private import log;
private import game;
private import charactor;
private import command;
private import axis;
private import player;
private import type;
private import shot;
private import opengl;
private import homing;
private import mygl;
private import sound;

class Player : public Charactor {
public:
	this(Game game, PadInput input) {
		game_ = game;
		input_ = input;

		type_ = Type.PLAYER_KURO;

		wait_ = 0;

		damageCnt_ = 0;
		shotPressingCnt_ = 0;

		rokNum_ = 0;

		barrierCnt_ = 0;
		barrierGauge_ = 1000;

		x_ = Kk.rc().getFloat("playerX");
		y_ = Kk.rc().getFloat("playerY");
		sx_ = 0;
		sy_ = 0;

		playerSpeed_ = Kk.rc().getFloat("playerSpeed");
		playerSpeed2_ = Kk.rc().getFloat("playerSpeed2");

		playerSize_ = Kk.rc().getInt("playerSize");
		playerFieldSize_ = Kk.rc().getInt("playerFieldSize");
		playerFieldSize2_ = (playerFieldSize_ * playerFieldSize_) << 2;

		screenWidth_ = Kk.rc().getInt("gameWidth") - playerSize_;
		screenHeight_ = Kk.rc().getInt("gameHeight") - playerSize_;

		barrierMinCnt_ = Kk.rc().getInt("playerBarrierMinCnt");
	}

	void move() {
		turn_++;
		damageCnt_--;
		autoShotCnt_--;

		bit button = input_.getButton(0);

		if (button) {
			shotPressingCnt_++;
			if (shotPressingCnt_ < 24) autoShotCnt_ = 8;
		}
		else shotPressingCnt_ = 0;

		float base;

		if (input_ == null) return;

		Axis axis = input_.getAxis();

		if (shotPressingCnt_ > 7) base = playerSpeed2_;
		else base = playerSpeed_;
		float cross = base / SQRT_2;

		sx_ = sy_ = 0;
		if (axis == Axis.UP) sy_ = -base;
		else if (axis == Axis.RIGHT) sx_ = base;
		else if (axis == Axis.DOWN) sy_ = base;
		else if (axis == Axis.LEFT) sx_ = -base;
		else if (axis == Axis.UPRIGHT) {
			sx_ = cross;
			sy_ = -cross;
		}
		else if (axis == Axis.DOWNRIGHT) {
			sx_ = cross;
			sy_ = cross;
		}
		else if (axis == Axis.DOWNLEFT) {
			sx_ = -cross;
			sy_ = cross;
		}
		else if (axis == Axis.UPLEFT) {
			sx_ = -cross;
			sy_ = -cross;
		}
		x_ += sx_;
		y_ += sy_;

		if (x_ < playerSize_) x_ = playerSize_;
		else if (x_ > screenWidth_) x_ = screenWidth_;
		if (y_ < playerSize_) y_ = playerSize_;
		else if (y_ > screenHeight_) y_ = screenHeight_;

		if (wait_ == 0) {
			if (input_.getButton(1) && barrierCnt_ == 0) {
				bool roked = false;
				if (shotPressingCnt_ > 24) {
					for (int i = 0; i < rokNum_; i++) {
						int cnt = (i + 1) >> 1;
						bit left = (i & 1) == 1;
						float rad = std.math.PI - std.math.PI / 22 * cnt;
						float sx = HOMING_SPEED*std.math.sin(rad);
						float sy = HOMING_SPEED*std.math.cos(rad);
						if (left) {
							sx = -sx;
							rad = -rad;
						}

						if (game_.addRok(
								new HomingShot(x_+sx, y_, sx, sy, rad,
											   HOMING_SPEED,
											   Type.PLAYER_HOMINGLASER,
											   game_))
							)
						{
							roked = true;
							rokNum_--;
						}
						else {
							break;
						}
					}
				}
				else {
					for (int i = 0; i < rokNum_; i++) {
						int cnt = (i + 1) >> 1;
						bit left = (i & 1) == 1;
						float rad = std.math.PI / 8 * cnt;
						float sx = HOMING_SPEED*std.math.sin(rad);
						float sy = HOMING_SPEED*std.math.cos(rad);
						if (left) {
							rad = -rad;
							sx = -sx;
						}

						if (game_.addRok(
								new HomingShot(x_+sx, y_, sx, sy, rad,
											   HOMING_SPEED,
											   Type.PLAYER_HOMINGLASER,
											   game_))
							)
						{
							roked = true;
							rokNum_--;
						}
						else {
							break;
						}
					}
				}
				if (roked) {
					Sound.obj.playChunk(Se.PLAYER_ROK);
				}
			}

			if (barrierCnt_ == 0) {
				if ((shotPressingCnt_ & 1) == 1 &&
					shotPressingCnt_ > 24) {
					if (shotPressingCnt_ > 16 && game_.canPlayerShot(6))
					{
						Sound.obj.playChunk(Se.PLAYER_LASER);

						game_.addPshot(
							new Shot(x_+25, y_+5, 0, -17,
									 Type.PLAYER_MAINLASER));
						game_.addPshot(
							new Shot(x_-25, y_+5, 0, -17,
									 Type.PLAYER_MAINLASER));
						game_.addPshot(
							new Shot(x_+15, y_+2, 0, -17,
									 Type.PLAYER_MAINLASER));
						game_.addPshot(
							new Shot(x_-15, y_+2, 0, -17,
									 Type.PLAYER_MAINLASER));
						if ((shotPressingCnt_ & 2) == 2) {
							game_.addPshot(
								new Shot(x_+10, y_, 0, -17,
										 Type.PLAYER_MAINLASER));
							game_.addPshot(
								new Shot(x_-10, y_, 0, -17,
										 Type.PLAYER_MAINLASER));
						}
						else {
							game_.addPshot(
								new Shot(x_-10, y_, 0, -17,
										 Type.PLAYER_MAINLASER));
							game_.addPshot(
								new Shot(x_+10, y_, 0, -17,
										 Type.PLAYER_MAINLASER));
						}
					}
				}
				else if (((shotPressingCnt_ & 1) == 1 ||
						  (shotPressingCnt_ == 0 &&
						   autoShotCnt_ > 0 && (autoShotCnt_ & 1) == 1)) &&
						 game_.canPlayerShot(6))
				{
					Sound.obj.playChunk(Se.PLAYER_SHOT);

					game_.addPshot(
						new Shot(x_+15, y_, 0, -10, Type.PLAYER_MAINSHOT));
					game_.addPshot(
						new Shot(x_-15, y_, 0, -10, Type.PLAYER_MAINSHOT));
					game_.addPshot(
						new Shot(x_+13, y_, 3, -10, Type.PLAYER_MAINSHOT));
					game_.addPshot(
						new Shot(x_-13, y_, -3, -10, Type.PLAYER_MAINSHOT));
					game_.addPshot(
						new Shot(x_+11, y_, 5, -10, Type.PLAYER_MAINSHOT));
					game_.addPshot(
						new Shot(x_-11, y_, -5, -10, Type.PLAYER_MAINSHOT));
				}
			}
		}
		else {
			wait_--;
		}

		if ((input_.getButton(2) && barrierGauge_ > 0) ||
			(barrierCnt_ > 0 && barrierCnt_ < barrierMinCnt_)) {
			if (barrierCnt_ == 0) {
				Sound.obj.playChunk(Se.PLAYER_BARRIER);
				barrierGauge_ -= 250;
			}
			else if (barrierCnt_ > barrierMinCnt_) {
				barrierGauge_ -= 2;
			}
			if (barrierGauge_ < 0) barrierGauge_ = 0;
			barrierCnt_++;
		}
		else {
			if (barrierCnt_ > 0) {
				Sound.obj.playChunk(Se.PLAYER_BARRIER_ATACK);
				barrierCnt_ = - barrierCnt_ - barrierMinCnt_;
			}
		}
		if (barrierCnt_ < 0) {
			barrierCnt_ += 2;
			if (barrierCnt_ > 0) barrierCnt_ = 0;
		}

		static const float[] axis2angle = [
			float.nan, std.math.PI, std.math.PI*0.75, std.math.PI*0.5, std.math.PI*0.25,
			0, -std.math.PI*0.25, -std.math.PI*0.5, -std.math.PI*0.75
			];
		a_ = axis2angle[axis.getSmallAxisCode()];
		s_ = base;
	}

	void input(PadInput input) {
		input_ = input;
	}

	void wait(int t) {
		wait_ = t;
	}

	float playerSpeed() { return playerSpeed_; }
	float playerSpeed2() { return playerSpeed2_; }

	int screenWidth() { return screenWidth_; }
	int screenHeight() { return screenHeight_; }

	void damage() {
		if (damageCnt_ < 0) {
			Log.info("damaged.");

			damageCnt_ = 180;
		}
	}

	void drawTop() {
		glPushMatrix();

		glTranslatef(x_, y_, 0);

		if (barrierCnt_ > 0) {
			glColor4f(0, 0, 0, 0.3);

			float size = barrierSize();

			for (int i = 0; i < 3; i++) {
				glRotatef(rnd(360), 0, 0, 1);
				myglCircle16(size);
			}
		}
		else if (barrierCnt_ < 0) {
			if (barrierCnt_ > -barrierMinCnt_) {
				glColor4f(0, 0, 0, -0.8*barrierCnt_/barrierMinCnt_);
			}
			else {
				glColor4f(0, 0, 0, 0.8);
			}

			float size = barrierSize();
/*
			static float[] xs =
				[ 0, 0.77, 1.4, 1.85, 2, 1.85, 1.4, 0.77, 0,
				  -0.77, -1.4, -1.85, -2, -1.85, -1.4, -0.77, 0 ];
			static float[] ys =
				[ 2, 1.85, 1.4, 0.77, 0, -0.77, -1.4, -1.85, -2,
				  -1.85, -1.4, -0.77, 0, 0.77, 1.4, 1.85,  2 ];
*/
			static float[] xs =
				[ 2, 1.85, 1.4, 0.77, 0, -0.77, -1.4, -1.85, -2 ];
			static float[] ys =
				[ 0, -0.77, -1.4, -1.85, -2, -1.86, -1.4, -0.77, 0 ];
			myglCircle(size, xs, ys);

			glBegin(GL_QUADS);

			glVertex3f(size*2, 0, 0);
			glVertex3f(-size*2, 0, 0);
			glVertex3f(-size*2, -y_, 0);
			glVertex3f(size*2, -y_, 0);
		}

		float v = std.math.sin(turn_/10) * 0.3 + 0.4;

		glColor4f(0.1, 0, 0, v);

		glBegin(GL_QUADS);

		glVertex3f(0, 10, 0);
		glVertex3f(1+v, 0, 0);
		glVertex3f(0, -10, 0);
		glVertex3f(-1-v, 0, 0);

		glEnd();

		glBegin(GL_QUADS);

		glVertex3f(10, 0, 0);
		glVertex3f(0, 1+v, 0);
		glVertex3f(-10, 0, 0);
		glVertex3f(0, -1-v, 0);

		glEnd();

		glPopMatrix();
	}

	void draw() {
		glPushMatrix();

		glTranslatef(x_, y_, 0);

		static int[] ints = [ -297, -171, -139, -77, -7,
							  23, 103, 207, 493, 901 ];

		if (damageCnt_ < 0) {
			glColor4f(1, 1, 1, 0.1);
		}
		else {
			float t = (damageCnt_ & 15) * 0.03;
			glColor4f(1, 1-t, 1-t, 0.1);
		}

		foreach (int i; ints) {
			glPushMatrix();

			glRotatef(turn_*i, 0, 0, 1);

			glBegin(GL_QUADS);

			glVertex3f(8, 8, 0);
			glVertex3f(8, -8, 0);
			glVertex3f(-8, -8, 0);
			glVertex3f(-8, 8, 0);

			glEnd();

			glPopMatrix();
		}

		glColor4f(0, 0, 0, 0.1);

		foreach (int i; ints) {
			glPushMatrix();

			glRotatef(turn_*i, 0, 0, 1);

			glBegin(GL_QUADS);

			glVertex3f(6, 6, 0);
			glVertex3f(6, -6, 0);
			glVertex3f(-6, -6, 0);
			glVertex3f(-6, 6, 0);

			glEnd();

			glPopMatrix();
		}

		glPopMatrix();

	}

	void addRokNum() {
		if (rokNum_ < 15) rokNum_++;
	}
	int rokNum() {
		return rokNum_;
	}
	void resetRokNum() {
		rokNum_ = 0;
	}

	float barrierSize() {
		if (barrierCnt_ > 0) {
			return 30 + barrierCnt_*0.1;
		}
		else if (barrierCnt_ < -barrierMinCnt_) {
			return - 30 + (barrierCnt_+barrierMinCnt_)*0.1;
		}
		else if (barrierCnt_ < 0) {
			return -30;
		}
		else {
			return 0;
		}
	}

	int barrierGauge() {
		return barrierGauge_ / 10;
	}

	bool damaging() {
		return damageCnt_ >= 0;
	}

private:
	Game game_;
	PadInput input_;

	float playerSpeed_;
	float playerSpeed2_;

	int color_;
	int opposite_;

	int playerSize_;
	int playerFieldSize_;
	int playerFieldSize2_;

	int screenWidth_;
	int screenHeight_;

	int wait_;

	int damageCnt_;

	char[] name_;

	int shotPressingCnt_;
	int autoShotCnt_;

	int rokNum_;

	int barrierCnt_;

	int barrierGauge_;

	int barrierMinCnt_;

private:
	static const float HOMING_SPEED = 7;

}
